
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <fstream>
#include <iostream>
#include <sstream>
#include <string>

#include "player.h"
#include "font.h"
#include "display.h"
#include "level.h"
#include "explore.h"
#include "misc.h"
#include "encounter.h"


monster Monsters[47];
monster opponent;
weapon Weapons[56];
int weaponProbabilities[6] = { 0,0,0,0,0,0 };
int weaponReferences[6] = { 0,0,0,0,0,0 };

extern Player plyr;
extern sf::RenderWindow App;

//sf::Music encounterMusic;
sf::SoundBuffer encBuffer, encBuffer2;
sf::Sound encSound, encSound2;


sf::Image encImageSheet;
sf::Sprite encImage;
string str, key; // for message text
int encounterMenu;

int opponentNo;
int flashCount;
int encAnimation;
bool flashTextOn;

double round(double d){  return floor(d + 0.5);}


void runEncounter()
{	
	
	encImageSheet.LoadFromFile("data/images/cityEncounterImages2.png");
	encImageSheet.CreateMaskFromColor(sf::Color(255, 0, 255));
	encImageSheet.SetSmooth(false);
	encounterMenu = 1; // high level menu
	plyr.status = 3; // encounter!
	bool encounterStarted = false;
	flashCount = 0;
	int opponentCount = 0;
	flashTextOn = true;
	opponentNo = sf::Randomizer::Random(0, 46); // pick random encounter
	//int opponentAlignment = Monsters[opponentNo].alignment;
	//if (opponentAlignment > 127) { encBuffer.LoadFromFile("data/audio/cityEncounter2.ogg"); }
	//if (opponentAlignment < 128){ encBuffer.LoadFromFile("data/audio/cityEncounter1.ogg"); }
	//encSound.SetBuffer(encBuffer);
	
	encAnimation = 1;
	bool musicPlaying = false;

	while ((encounterMenu > 0) && (plyr.alive))
	{	
		//if (!musicPlaying) { encSound.Play(); musicPlaying = true; }
		drawEncounterView();
			
		// Draw high level encounter menu
			
		cyText (2, "Encounter Options");
		bText (5,4, "  ) Attack");
		bText (5,5, "  ) Charge");
		bText (5,6, "  ) Aimed Attack");
		bText (5,7, "  ) Switch weapon");
		bText (5,8, "  ) Charm");
		bText (5,9, "  ) Trick");
		bText (24,4, "  ) Hail");
		bText (24,5, "  ) Offer");
		bText (24,6, "  ) Cast spell");
		bText (24,7, "  ) Use items");
		bText (24,8, "  ) Leave");
		SetFontColour(40, 96, 244, 255);
		bText (6,4, "1");
		bText (6,5, "2");
		bText (6,6, "3");
		bText (6,7, "4");
		bText (6,8, "5");
		bText (6,9, "6");
		bText (25,4, "7");
		bText (25,5, "8");
		bText (25,6, "C");
		bText (25,7, "U");
		bText (25,8, "0");
		SetFontColour(255, 255, 255, 255);
			
	
			if ( !encounterStarted ) 
			{	
				opponent.alignment = 0;
				initMonster(opponentNo);
				//int opponentAlignment = Monsters[opponentNo].alignment;
				if (opponent.alignment > 127) { encBuffer2.LoadFromFile("data/audio/cityEncounter2.ogg"); encSound.SetBuffer(encBuffer2); }
				if (opponent.alignment < 128){ encBuffer.LoadFromFile("data/audio/cityEncounter1.ogg"); encSound.SetBuffer(encBuffer); }
				
				encounterStarted = true;
			}

			if (!musicPlaying) { encSound.Play(); musicPlaying = true; }
			
			
						

			if (plyr.diagOn) { displayMonsterDiag(); }

			App.Display(); // Refresh screen so drawn items are visible
	
			key = getSingleKey();
			if  (key=="0") { encounterMenu = 0; }
			if  (key=="1") { playerAttack(1,0); } // standard attack
			if ( key=="2" ) { playerAttack(2,0.25); } // charge
			if ( key=="3" ) { playerAttack(3,0.25); } // Aimed attack
			if ( key=="4" ) { playerSwitchWeapons(); } 
			if ( key=="5" ) { playerCharm(); }
			if ( key=="6" ) { playerTrick(); }
			if ( key=="7" ) { playerHail(); }
			//if ( key=="8" ) { playerOffer(); }

			if (opponentCount == 199) { opponentAttack(); }
			if (opponentCount == 200) { opponentCount=0; }
			opponentCount++;
			
		}

	}

void playerSwitchWeapons()
{
	bool keynotpressed = true;
	bool weaponsSwitched = false;
	while ( keynotpressed )
	{
		drawEncounterView();
		if (!weaponsSwitched)
		{
			str = "Switching to " + Weapons[plyr.secWeapon].name + ".";
			int oldPrimary = plyr.priWeapon;
			plyr.priWeapon = plyr.secWeapon;
			plyr.secWeapon = oldPrimary;
			weaponsSwitched = true;
		}
		cyText(4, str);
		App.Display();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
}

void playerHail()
{
	bool keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		str = "The " + opponent.name + " seems uninterested.";
		cyText(4, str);
		App.Display();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
}


void playerOffer()
{

}


void playerCharm()
{
	// hostile act - make opponent hostile
	bool charmSuccess = false;
	if ( (opponent.baseIntelligence > 5) && (plyr.chr != 0) )
	{
		// Check for a successful Charm attempt
		int chrIntDifference = plyr.chr - opponent.baseIntelligence;
		int charmProbability;
		if (chrIntDifference <= -128) { charmProbability = 1; }
		if ( (chrIntDifference >= -128) && (chrIntDifference < -64) )  { charmProbability = 2; }
		if ( (chrIntDifference >= -64) && (chrIntDifference < 0) )  { charmProbability = 7; }
		if ( (chrIntDifference >= 0) && (chrIntDifference < 64) )  { charmProbability = 25; }
		if ( (chrIntDifference >= 64) && (chrIntDifference < 128) )  { charmProbability = 50; }
		if ( (chrIntDifference >= 128) && (chrIntDifference < 192) )  { charmProbability = 70; }
		if (chrIntDifference >= 192) { charmProbability = 80; }
		
		int hitRoll = sf::Randomizer::Random(1,100);
		if (hitRoll <= charmProbability) { charmSuccess = true; }
		

	}
	//if (!charmSuccess) { // 50% test that future charm attempts always fail }
	bool keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		
		if ( charmSuccess) { str = "You charmed it!"; }
		else { str = "You failed to charm it!"; }
		cyText(4, str);
		App.Display();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
	if ( charmSuccess ) { int opponentXP = (opponent.baseIntelligence*3) + (opponent.baseSkill*3) + (opponent.baseStrength*3);
	increaseExperience(opponentXP); plyr.chrPartials++; encounterMenu = 0; }
	if ( !charmSuccess ) { opponentAttack(); }
}


void playerTrick()
{
	// hostile act - make opponent hostile
	bool trickSuccess = false;
	if ( (opponent.baseIntelligence > 3) && (plyr.inte != 0) )
	{
		// Check for a successful trick attempt
		int intelligenceDifference = plyr.inte - opponent.baseIntelligence;
		int trickProbability;
		if (intelligenceDifference <= -128) { trickProbability = 1; }
		if ( (intelligenceDifference >= -128) && (intelligenceDifference < -64) )  { trickProbability = 1; }
		if ( (intelligenceDifference >= -64) && (intelligenceDifference < 0) )  { trickProbability = 7; }
		if ( (intelligenceDifference >= 0) && (intelligenceDifference < 64) )  { trickProbability = 19; }
		if ( (intelligenceDifference >= 64) && (intelligenceDifference < 128) )  { trickProbability = 47; }
		if ( (intelligenceDifference >= 128) && (intelligenceDifference < 192) )  { trickProbability = 75; }
		if (intelligenceDifference >= 192) { trickProbability = 90; }
		
		int hitRoll = sf::Randomizer::Random(1,100);
		if (hitRoll <= trickProbability) { trickSuccess = true; }
		

	}
	//if (!trickSuccess) { // 50% test that future trick attempts always fail }
	if ( trickSuccess) { plyr.intPartials++; str = "You tricked it!"; }
	else { str = "You failed to trick it!"; }
	bool keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		cyText(4, str);
		App.Display();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
	if ( trickSuccess ) { int opponentXP = (opponent.baseIntelligence*3) + (opponent.baseSkill*3) + (opponent.baseStrength*3);
	increaseExperience(opponentXP); encounterMenu = 0; }
	if ( !trickSuccess ) { opponentAttack(); }

}

void playerAttack(int attackType, float attackFactorBonus)
{
	bool playerIsAttacking = true;
	bool hitSuccess;
	float attackFactor = 1.00;
	// float attackFactorBonus = 0;
	if ((Weapons[(plyr.priWeapon)].useStrength==1)) 
	
	{
		//Calculate attack factor bonus if weapon uses Strength
		int strengthDifference = plyr.str - opponent.baseStrength;
		if (strengthDifference <= -128) { attackFactorBonus += 0.0625; }
		if ( (strengthDifference >= -128) && (strengthDifference < -64) )  { attackFactorBonus += 0.125; }
		if ( (strengthDifference >= -64) && (strengthDifference < 0) )  { attackFactorBonus += 0.5; }
		if ( (strengthDifference >= 0) && (strengthDifference < 64) )  { attackFactorBonus += 0.75; }
		if ( (strengthDifference >= 64) && (strengthDifference < 128) )  { attackFactorBonus += 0.875; }
		if ( (strengthDifference >= 128) && (strengthDifference < 192) )  { attackFactorBonus += 1; }
		if (strengthDifference >= 192) { attackFactorBonus += 1; }
	}
	attackFactor += attackFactorBonus;

	// Hit probability
	int skillDifference = plyr.skl - opponent.baseSkill;
	int hitProbability;
	if (skillDifference <= -128) { hitProbability = 1; }
	if ( (skillDifference >= -128) && (skillDifference < -64) )  { hitProbability = 19; }
	if ( (skillDifference >= -64) && (skillDifference < 0) )  { hitProbability = 50; }
	if ( (skillDifference >= 0) && (skillDifference < 64) )  { hitProbability = 63; }
	if ( (skillDifference >= 64) && (skillDifference < 128) )  { hitProbability = 69; }
	if ( (skillDifference >= 128) && (skillDifference < 192) )  { hitProbability = 76; }
	if (skillDifference >= 192) { hitProbability = 100; }
	if (attackType==3) { hitProbability -= 5; } // penalty for charge attack
	int hitRoll = sf::Randomizer::Random(1,100);
	if (hitRoll <= hitProbability) { hitSuccess = true; }
	else {  hitSuccess = false; }
	
	if (!hitSuccess)
	{
		if (attackType==3)
		{
			if (sf::Randomizer::Random(1,2)==1) { str = "You wait for an opening."; }
			else { str = "You miss."; }
			
		}
		else
		{
			str = "You miss.";
		}
	}

	if (hitSuccess)
	{
		int damage = calculateWeaponDamage(plyr.priWeapon, attackFactor, 0);
	
		if (damage != 1000) { opponent.baseHP-=damage; increaseExperience(damage); }
		
		//damage [type] = Random [0; Round (base weapon damage [type] * attack factor)]
		str = "You attack the " + opponent.name + "@with "+ Weapons[plyr.priWeapon].name + "@for " + itos(damage) + ".";
		if (damage==0) { str = "You attack the " + opponent.name + "@with "+ Weapons[plyr.priWeapon].name + "@which has no effect!"; }
		if (damage==1000) { str = "You attack the " + opponent.name + "@with "+ Weapons[plyr.priWeapon].name + "@which is stopped by its " + opponent.armorText + "."; }	
	}

	while ( playerIsAttacking )
	{
		drawEncounterView();
		cyText(4, str);
		App.Display();
		key = getSingleKey();
		if (key!="") { playerIsAttacking = false; }
	}
	if ( opponent.baseHP<0) {opponentDeath(); }
	else 
	{
		opponentAttack(); // add chance of parry reduction here
	}
}

void opponentDeath()
{
bool keynotpressed = true;
while ( keynotpressed )
	{
		drawEncounterView();
		str = "The " + opponent.name + " has died!";
		cyText(4, str);
		App.Display();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
 
	int opponentXP = (opponent.baseIntelligence*3) + (opponent.baseSkill*3) + (opponent.baseStrength*3);
	increaseExperience(opponentXP);
	encounterMenu = 0;
}

void opponentAttack()
{
	bool opponentIsAttacking = true;
	bool hitSuccess;
	weapon opponentWeapon;

	int chosenWeapon = opponentChooseWeapon();
	opponentWeapon = Weapons[chosenWeapon];
	//opponentWeapon = Weapons[opponent.weapon1];

	// Hit probability
	int skillDifference = opponent.baseSkill - plyr.skl;
	int hitProbability;
	if (skillDifference <= -128) { hitProbability = 1; }
	if ( (skillDifference >= -128) && (skillDifference < -64) )  { hitProbability = 19; }
	if ( (skillDifference >= -64) && (skillDifference < 0) )  { hitProbability = 50; }
	if ( (skillDifference >= 0) && (skillDifference < 64) )  { hitProbability = 63; }
	if ( (skillDifference >= 64) && (skillDifference < 128) )  { hitProbability = 69; }
	if ( (skillDifference >= 128) && (skillDifference < 192) )  { hitProbability = 76; }
	if (skillDifference >= 192) { hitProbability = 100; }
	int hitRoll = sf::Randomizer::Random(1,100);
	if (hitRoll <= hitProbability) { hitSuccess = true; }
	else {  hitSuccess = false; }
	
	if (!hitSuccess)
	{
		str = "The " + opponent.name + " misses.";
	}

	if (hitSuccess)
	{
		//int damage = sf::Randomizer::Random(1,6); // CHANGE!!!
		float attackFactor = 1.0; // change!
		int damage = calculateWeaponDamage(chosenWeapon,attackFactor, 1);
		if (damage!=1000) { plyr.hp-=damage; }
		str = "The " + opponent.name + " " + opponentWeapon.desc + "@you with "+ opponentWeapon.name + "@for " + itos(damage) + ".";
		if (damage==0) { str = "The " + opponent.name + " " + opponentWeapon.desc + "@you with "+ opponentWeapon.name + "@which has no effect!"; }
		if (damage==1000) { str = "The " + opponent.name + " " + opponentWeapon.desc + "@you with "+ opponentWeapon.name + "@which is stopped by your skin!"; }
	}

	while ( opponentIsAttacking )
	{
		drawEncounterView();
		cyText(4, str);
		App.Display();
		key = getSingleKey();
		if (key!="") { opponentIsAttacking = false; }
	}
	if (plyr.hp<0) { plyr.alive=false; }
}

int calculateWeaponDamage(int weaponNo, float attackFactor, int attacker)
{
	// attacker - 0 = player, 1 = monster
	int weaponDamageValues[9];
	weaponDamageValues[0] = Weapons[weaponNo].blunt;
	weaponDamageValues[1] = Weapons[weaponNo].sharp;
	weaponDamageValues[2] = Weapons[weaponNo].earth;
	weaponDamageValues[3] = Weapons[weaponNo].air;
	weaponDamageValues[4] = Weapons[weaponNo].fire;
	weaponDamageValues[5] = Weapons[weaponNo].water;
	weaponDamageValues[6] = Weapons[weaponNo].power;
	weaponDamageValues[7] = Weapons[weaponNo].mental;
	weaponDamageValues[8] = Weapons[weaponNo].cleric;
	
	int armorValues[9] = { 0,0,0,0,0,0,0,0,0 };
	// Need to add modifier for player armor values & armor body parts
	if (attacker==0)
	{
		armorValues[0] = opponent.armorBlunt;
		armorValues[1] = opponent.armorSharp;
		armorValues[2] = opponent.armorEarth;
		armorValues[3] = opponent.armorAir;
		armorValues[4] = opponent.armorFire;
		armorValues[5] = opponent.armorWater;
		armorValues[6] = opponent.armorPower;
		armorValues[7] = opponent.armorMental;
		armorValues[8] = opponent.armorCleric;
	}

	int damages[9];
	int damageIndex = 0; // 0 is sharp, 1 is blunt etc, 9 damage types in total
	
	while (damageIndex < 9)
	{
	int currentDamage = round((weaponDamageValues[damageIndex])* attackFactor);
	// armor check!
	damages[damageIndex] = sf::Randomizer::Random(0,currentDamage);
	damageIndex++;
	}
	int totalDamage = damages[0] + damages[1] + damages[2] + damages[3] + damages[4] + damages[5] + damages[6] + damages[7] + damages[8];
	if (totalDamage==0) { return totalDamage; }
	else
	{
		//check armor
		for(int i = 0; i < 9; ++i) // number of damage types to compare against armor efficiencies
		{
		// Add multiplier for armor efficiencies (fire for fire demons)
		damages[i] -= sf::Randomizer::Random(0,armorValues[i]);
		if ( damages[i] < 0 ) { damages[i] = 0; }
		}
		totalDamage = damages[0] + damages[1] + damages[2] + damages[3] + damages[4] + damages[5] + damages[6] + damages[7] + damages[8];
		//if (totalDamage<0) { return 1000; }
		if (totalDamage==0) { return 1000; }
		if (totalDamage >0) { return totalDamage; }
	}
}

int opponentChooseWeapon()
{
	weaponProbabilities[0] = opponent.weapon1chance;
	weaponProbabilities[1] = opponent.weapon2chance;
	weaponProbabilities[2] = opponent.weapon3chance;
	weaponProbabilities[3] = opponent.weapon4chance;
	weaponProbabilities[4] = opponent.weapon5chance;
	weaponProbabilities[5] = opponent.weapon6chance;

	weaponReferences[0] = opponent.weapon1;
	weaponReferences[1] = opponent.weapon2;
	weaponReferences[2] = opponent.weapon3;
	weaponReferences[3] = opponent.weapon4;
	weaponReferences[4] = opponent.weapon5;
	weaponReferences[5] = opponent.weapon6;

	int chosenWeaponNo = 255;
	int weaponProbability = sf::Randomizer::Random(1,100);
	int weaponProbabilityTotal = 0;
	int weaponIndex = 0;
	//int weaponIndexProbability = 0;
	while (chosenWeaponNo == 255)
	{ 
		weaponProbabilityTotal += weaponProbabilities[weaponIndex];
		if ( weaponProbability <= weaponProbabilityTotal ) { chosenWeaponNo = weaponReferences[weaponIndex]; }
		if (weaponIndex == 6) { chosenWeaponNo = 0; } // error weapon!
		weaponIndex++;
	}
	return chosenWeaponNo;
}


void initMonster(int monsterNo)
{
	opponent = Monsters[monsterNo]; // copy monster details to current opponent object
	opponent.baseHP += sf::Randomizer::Random(0,Monsters[monsterNo].randomHP);
	opponent.baseStrength += sf::Randomizer::Random(0,Monsters[monsterNo].randomStrength);
	opponent.baseSkill += sf::Randomizer::Random(0,Monsters[monsterNo].randomSkill);
	opponent.baseIntelligence += sf::Randomizer::Random(0,Monsters[monsterNo].randomIntelligence);
	opponent.baseSpeed += sf::Randomizer::Random(0,Monsters[monsterNo].randomSpeed);
}





void drawEncounterView()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	drawCompass();
	buildLevelView();
	drawStatsPanel();

	// Alternate and set animation frame as required
	encImage.SetImage(encImageSheet);
	encImage.SetPosition(310, 176);
	
	if (Monsters[opponentNo].image2==0) { SetTileImage(Monsters[opponentNo].image); }
	if (Monsters[opponentNo].image2!=0) 
	{
		if (encAnimation==1) { SetTileImage(Monsters[opponentNo].image); }
		if (encAnimation==2) { SetTileImage(Monsters[opponentNo].image2); }
		
		if ( flashCount==40)
		{	
			if (encAnimation==1) { encAnimation=2; }
			else { encAnimation=1; }
		}
	}
	// Nightstalker & dragon image position changes
	if (Monsters[opponentNo].image==86) { encImage.SetPosition(306, 168); }
	if (Monsters[opponentNo].image==82) { encImage.SetPosition(306, 176); }
	App.Draw(encImage);
	
	flashCount++;
	//if ((flashCount==20) && (!flashTextOn)) { flashTextOn = true; flashCount = 0; }
	//if ((flashCount==60) && (flashTextOn)) { flashTextOn = false; flashCount = 0; }
	SetFontColour(111, 159, 6, 255);
	
	// Draw status line text
	string text;
	if ( (Monsters[opponentNo].name.substr (0,1)=="A") ||
		(Monsters[opponentNo].name.substr (0,1)=="O") ||
		(Monsters[opponentNo].name.substr (0,1)=="I")) 
		{text = "You encounter an "+Monsters[opponentNo].name;}
	else { text = "You encounter a "+Monsters[opponentNo].name; }
	drawText(2,6,text);
	SetFontColour(255, 255, 255, 255);

	if (flashCount == 60) { flashCount = 0; }
}


















void displayMonsterDiag()
{
	drawText(33,8,"HP: ");
	drawText(37,8,opponent.baseHP);
	drawText(33,9,"ALN:");
	drawText(37,9,opponent.alignment);
	drawText(33,10,"SKL:");
	drawText(37,10,opponent.baseSkill);
	drawText(33,11,"INT:");
	drawText(37,11,opponent.baseIntelligence);
	drawText(33,12,"SPD:");
	drawText(37,12,opponent.baseSpeed);
}















void SetTileImage(int tile_no)
{
	
	int row, column;
	int tilesPerRow = 8; // number of tiles per row in source image containing all tiles (8 default)
	int tilesPerColumn = 8; // number of tiles per column in source image (8 default)
	
	//Select 64x128 section of tile sheet for tile
	
	if ( tile_no > tilesPerRow)
	{
		column = (tile_no % tilesPerRow); // remainder
		row = ((tile_no-column)/tilesPerRow);
	}
	else
	{
		column = tile_no;
		row = 0; // = row 1 on the actual tile sheet at y=0
	}

	int tileX = (column)*64;	// x loc on tiles image in pixels
	int tileY = (row)*128;		// y loc on tiles image in pixels
	encImage.SetSubRect(sf::IntRect(tileX, tileY , (tileX+64), (tileY+128)));

	// Nightstalker & Dragon exceptions due to larger image size
	if (tile_no==86) { encImage.SetSubRect(sf::IntRect(tileX, tileY , (tileX+72), (tileY+136))); }
	if (tile_no==82) { encImage.SetSubRect(sf::IntRect(tileX, tileY , (tileX+72), (tileY+128))); }
}



void loadCityMonsters()
{

	std::ifstream instream;
	std::string junk,junk2, data;

	instream.open("data\\map\\cityMonsters2.txt");
	if( !instream ) 
	{
      cerr << "Error: City monsters file could not be loaded" << endl;
	}

	for(int i = 0; i < 47; ++i) // number of monsters - test for 2
	{	
		string junk, line, text;
		int monster_attributes = 45; // should be 45
		string::size_type idx;
		getline(instream, junk); // read first line as blank
		for (int a = 0; a < monster_attributes; ++a) // number of attributes - test for 33
		{
			getline(instream, line);
			idx = line.find('=');
			text = line.substr(idx+2);
			//cout << a << ", " << text << "\n";
			if (a==0) { Monsters[i].name = text; }
			if (a==1) { Monsters[i].armorText = text; }
			if (a==2) { Monsters[i].behaviour = atoi(text.c_str()); }
			if (a==3) { Monsters[i].alignment = atoi(text.c_str()); }
			if (a==4) { Monsters[i].stealth = atoi(text.c_str()); }
			if (a==5) { Monsters[i].baseStrength = atoi(text.c_str()); }
			if (a==6) { Monsters[i].randomStrength = atoi(text.c_str()); }
			if (a==7) { Monsters[i].baseSkill = atoi(text.c_str()); }
			if (a==8) { Monsters[i].randomSkill = atoi(text.c_str()); }
			if (a==9) { Monsters[i].baseIntelligence = atoi(text.c_str()); }
			if (a==10) { Monsters[i].randomIntelligence = atoi(text.c_str()); }
			if (a==11) { Monsters[i].baseSpeed = atoi(text.c_str()); }
			if (a==12) { Monsters[i].randomSpeed = atoi(text.c_str()); }
			if (a==13) { Monsters[i].baseHP = atoi(text.c_str()); }
			if (a==14) { Monsters[i].randomHP = atoi(text.c_str()); }
			if (a==15) { Monsters[i].image = atoi(text.c_str()); }
			if (a==16) { Monsters[i].image2 = atoi(text.c_str()); }

			if (a==17) { Monsters[i].armorBlunt = atoi(text.c_str()); }
			if (a==18) { Monsters[i].armorSharp = atoi(text.c_str()); }
			if (a==19) { Monsters[i].armorEarth = atoi(text.c_str()); }
			if (a==20) { Monsters[i].armorAir = atoi(text.c_str()); }
			if (a==21) { Monsters[i].armorFire = atoi(text.c_str()); }
			if (a==22) { Monsters[i].armorWater = atoi(text.c_str()); }
			if (a==23) { Monsters[i].armorPower = atoi(text.c_str()); }
			if (a==24) { Monsters[i].armorMental = atoi(text.c_str()); }
			if (a==25) { Monsters[i].armorCleric = atoi(text.c_str()); }

			if (a==26) { Monsters[i].treasurePotions = atoi(text.c_str()); }
			if (a==27) { Monsters[i].treasureEquipment = atoi(text.c_str()); }
			if (a==28) { Monsters[i].treasureCopper = atoi(text.c_str()); }
			if (a==29) { Monsters[i].treasureSilver = atoi(text.c_str()); }
			if (a==30) { Monsters[i].treasureGold = atoi(text.c_str()); }
			if (a==31) { Monsters[i].treasureGems = atoi(text.c_str()); }
			if (a==32) { Monsters[i].treasureJewels = atoi(text.c_str()); }

			if (a==33) { Monsters[i].weapon1 = atoi(text.c_str()); }
			if (a==34) { Monsters[i].weapon2 = atoi(text.c_str()); }
			if (a==35) { Monsters[i].weapon3 = atoi(text.c_str()); }
			if (a==36) { Monsters[i].weapon4 = atoi(text.c_str()); }
			if (a==37) { Monsters[i].weapon5 = atoi(text.c_str()); }
			if (a==38) { Monsters[i].weapon6 = atoi(text.c_str()); }

			if (a==39) { Monsters[i].weapon1chance = atoi(text.c_str()); }
			if (a==40) { Monsters[i].weapon2chance = atoi(text.c_str()); }
			if (a==41) { Monsters[i].weapon3chance = atoi(text.c_str()); }
			if (a==42) { Monsters[i].weapon4chance = atoi(text.c_str()); }
			if (a==43) { Monsters[i].weapon5chance = atoi(text.c_str()); }
			if (a==44) { Monsters[i].weapon6chance = atoi(text.c_str()); }
			
		}
		getline(instream, junk);
		//cout << "\n\n";
	}
	instream.close();
}

void loadCityWeapons()
{

	std::ifstream instream;
	std::string junk,junk2, data;

	instream.open("data\\map\\cityWeapons.txt");
	if( !instream ) 
	{
      cerr << "Error: City weapons file could not be loaded" << endl;
	}

	for(int i = 0; i < 56; ++i) // number of weapons
	{	
		string junk, line, text;
		int weapon_attributes = 17; // should be 17
		string::size_type idx;
		getline(instream, junk); // read first line as blank
		for (int a = 0; a < weapon_attributes; ++a) // number of attributes - test for 33
		{
			getline(instream, line);
			idx = line.find('=');
			text = line.substr(idx+2);
			//cout << a << ", " << text << "\n";
			if (a==0) { Weapons[i].name = text; }
			if (a==1) { Weapons[i].desc = text; }
			if (a==2) { Weapons[i].type = atoi(text.c_str()); }
			//if (a==3) { Weapons[i].rollLevel = atoi(text.c_str()); }
			if (a==3) { Weapons[i].baseAntiparry = atoi(text.c_str()); }
			if (a==4) { Weapons[i].randomAntiparry = atoi(text.c_str()); }
			if (a==5) { Weapons[i].attackRolls = atoi(text.c_str()); }
			if (a==6) { Weapons[i].attackRollValue = atoi(text.c_str()); }
			if (a==7) { Weapons[i].useStrength = atoi(text.c_str()); }
			if (a==8) { Weapons[i].blunt = atoi(text.c_str()); }
			if (a==9) { Weapons[i].sharp = atoi(text.c_str()); }
			if (a==10) { Weapons[i].earth = atoi(text.c_str()); }
			if (a==11) { Weapons[i].air = atoi(text.c_str()); }
			if (a==12) { Weapons[i].fire = atoi(text.c_str()); }
			if (a==13) { Weapons[i].water = atoi(text.c_str()); }
			if (a==14) { Weapons[i].power = atoi(text.c_str()); }
			if (a==15) { Weapons[i].mental = atoi(text.c_str()); }
			if (a==16) { Weapons[i].cleric = atoi(text.c_str()); }
		}
		getline(instream, junk);
		//cout << "\n\n";
	}
	instream.close();
}