#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <string>
#include <iostream>

#include "player.h"
#include "font.h"
#include "display.h"
#include "level.h"
#include "explore.h"
#include "misc.h"
#include "encounter.h"

#include "guild.h"
#include "bank.h"
#include "tavern.h"
#include "smithy.h"
#include "inn.h"
#include "shop.h"
#include "healer.h"
#include "staircase.h"

//#include "encounter.h"
//using namespace std;

extern string mess[25];
extern string room_descriptions[203];
extern Mapcell levelmap[4096];
extern Player plyr;
extern Teleport teleports[32];
extern sf::RenderWindow App;

sf::SoundBuffer doorBuffer;
sf::SoundBuffer secretBuffer;
sf::SoundBuffer smithyBuffer;
sf::Sound doorSound;
sf::Sound secretSound;
sf::Sound smithySound;
bool smithyPlaying;
sf::Music deathMusic;
bool gameQuit;

int teleColour = 1;
sf::Image teleBlack,teleGold;
sf::Sprite tBackground;

void explore()
{  	
	gameQuit = false;
	// Load a sound buffer from a wav file
	doorBuffer.LoadFromFile("data/audio/door.wav");
	secretBuffer.LoadFromFile("data/audio/citySecretDoor.wav");
	smithyBuffer.LoadFromFile("data/audio/smithyHammer3.wav");
	doorSound.SetBuffer(doorBuffer);
	secretSound.SetBuffer(secretBuffer);
	smithySound.SetBuffer(smithyBuffer);
	smithySound.SetLoop(true);

	teleBlack.LoadFromFile("data/images/teleport_black.png");
	teleGold.LoadFromFile("data/images/teleport_gold.png");

    bool Running = true;
	bool smithyPlaying = false;
	int timer=0;
	
	
    while (Running)
    {
		while ((Running) && (plyr.alive))
		{
		if (plyr.scenario ==1) {checkTeleport();}
		// checkForItemsHere();
		checkShop();
	 
	

	//	plyr.status_text = " ";
		//checkForItemsHere();
	  
		/* Update player loc details */
	    
		int ind = getMapIndex(plyr.x,plyr.y);
		transMapIndex(ind);
		plyr.special = levelmap[ind].special;
		plyr.location = levelmap[ind].location;
		setCurrentZone();
		
	    
		// Check for encounter every 20 passes through the exploring loop
		if (timer==20)
		{
			timer=0;
			int encounter_check = sf::Randomizer::Random(0, plyr.stealth);
			if ((encounter_check == 0) && (plyr.scenario==0)) { runEncounter(); }
		}
		timer++;
		

		
        // Clear color and depth buffer
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		drawCompass();
		
		drawInfoPanels();

		if (plyr.teleporting>0)
		{
			tBackground.SetPosition(156.f, 122.f);
			if (teleColour == 1) { tBackground.SetImage(teleGold); teleColour = 0; }
			else { tBackground.SetImage(teleBlack); teleColour = 1; } 
			plyr.teleporting--;
			App.Draw(tBackground);
		}
		else
		{
			buildLevelView();
		}

		drawStatsPanel();
		
		// Finally, display rendered frame on screen
		App.Display();

		if ( (plyr.special==1000) && (!smithyPlaying) ) { smithySound.Play(); smithyPlaying = true; }
		if ( (smithyPlaying) && (plyr.special!=1000) ) { smithySound.Stop(); smithyPlaying = false; }

		
		//string keyString;
		string key = readKey();
		if ( key=="left" ) { turnLeft(); }
		if ( key=="right" ) { turnRight(); }
		if ( key=="up" ) { moveForward(); }
		if ( key=="," ) { togglePanelsForward();}
		if ( key=="." ) { togglePanelsBackward(); }
		if ( key=="D" ) { if (plyr.diagOn) {plyr.diagOn = false;} else {plyr.diagOn = true;} }
		if ( key=="E" ) { runEncounter(); } // forced encounter - temporary
		if ( key=="QUIT" ) { Running=false; gameQuit=true; }
	}
		if (!gameQuit) { playerDies(); }
		Running=false;

	}
}


void playerDies()
{
	bool deathLooping = true;
	bool musicPlaying = false;
	deathMusic.OpenFromFile("data/audio/cityDeath.ogg"); 
	if (!musicPlaying) { deathMusic.Play(); musicPlaying = true; }

	while ( deathLooping )
	{
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		drawStatsPanel();
		cyText (3, "You're DEAD.");
		cyText (8, "(Press SPACE BAR to continue)");
		App.Display();
		string key = getSingleKey();
		if (key!="") { deathLooping = false; }
	}
	if (musicPlaying) { deathMusic.Stop(); }
}


void togglePanelsForward()
{
     plyr.infoPanel++;
     if (plyr.infoPanel == 4) { plyr.infoPanel = 1; }
}

void togglePanelsBackward()
{
     plyr.infoPanel--;
     if (plyr.infoPanel == 0) { plyr.infoPanel = 3; }
}


void moveWest()
{
	if (plyr.z_offset>1.9f) 
	{
		plyr.z_offset=0.0f;
		plyr.x--;
	}
	else
	{
		plyr.z_offset=plyr.z_offset+0.1f; 
	}			
}

void moveEast()
{
	if (plyr.z_offset>1.9f) 
	{
		plyr.z_offset=0.0f;
		plyr.x++;
	}
	else
	{
		plyr.z_offset=plyr.z_offset+0.1f;
	}		
}

void moveNorth()
{
	if (plyr.z_offset>1.9f) 
	{
		plyr.z_offset=0.0f;
		plyr.y--;
	}
	else
	{
		plyr.z_offset=plyr.z_offset+0.1f;
	}
}

void moveSouth()
{
	if (plyr.z_offset>1.9f) 
	{
		plyr.z_offset=0.0f;
		plyr.y++;
	}
	else
	{
		plyr.z_offset=plyr.z_offset+0.1f;
	}	
}


void moveForward()
{
    if ( (plyr.front != 13) || (plyr.z_offset< 1.7))
	{ 
        switch(plyr.facing)
        {
        case 1: // w
			moveWest();
			break;
    
        case 2: // n
			moveNorth();
            break;
    
        case 3: // e
			moveEast();
			break;
            
        case 4: // s
			moveSouth();
			break; 
        }
        
        if (( plyr.front == 5 ) && (plyr.z_offset > 1.8)) // secret door
        {
			plyr.z_offset=0.3f;
			
		
			switch(plyr.facing)
			{
				case 1: // w
					plyr.x--;
					break;
		    
				case 2: // n
					plyr.y--;
					break;
		    
				case 3: // e
					plyr.x++;
					break;		            
				case 4:
					plyr.y++; // s
					break; 
			}
			secretSound.Play();
			//sf::Sleep(0.1f);
        }

        if (( plyr.front == 3 ) && (plyr.z_offset > 1.8)) // door
        {
			plyr.z_offset=0.3f;
			 
			switch(plyr.facing)
			{
				case 1: // w
					plyr.x--;
					break;
		    
				case 2: // n
					plyr.y--;
					break;
		    
				case 3: // e
					plyr.x++;
					break;
		            
				case 4:
					plyr.y++; // s
					break; 
			}
			doorSound.Play();
		}

	 if ( ( plyr.front > 25 ) && ( plyr.front < 50 ) && (plyr.z_offset > 1.8)) // City doors with signs
     {
			plyr.z_offset=0.3f;
			 
			switch(plyr.facing)
			{
				case 1: // w
					plyr.x--;
					break;
		    
				case 2: // n
					plyr.y--;
					break;
		    
				case 3: // e
					plyr.x++;
					break;
		            
				case 4:
					plyr.y++; // s
					break; 
			
			}
			doorSound.Play();
	  }
		
    }
}



void moveBack()
{
    if ( plyr.back != 13 )
	{
        switch(plyr.facing)
        {
        case 1: // w
            plyr.x++;
            break;
    
        case 2: // n
            plyr.y++;
            break;
    
        case 3: // e
        	plyr.x--;
            break;
            
        case 4: // s
        	plyr.y--;
        	break;
        }
        
        if ( plyr.back == 5 ) // secret door
        {
        //    secret = Mix_LoadWAV("data/audio/secret.wav");
         //    secret_channel = Mix_PlayChannel(-1, secret, 0); 
        }
        if ( plyr.back == 3 ) // door
        {
           //  door = Mix_LoadWAV("data/audio/door.wav");
           //  door_channel = Mix_PlayChannel(-1, door, 0); 
        }
    }
}



void turnLeft()
{
	switch(plyr.facing)
    {
    case 2: // n
		
        plyr.facing = 1;
		plyr.z_offset=1.0f;
        break;

    case 1: //  facing w before turning
		
        plyr.facing = 4;
		plyr.z_offset=1.0f;
        break;

    case 3: // e
		
    	plyr.facing = 2;
		plyr.z_offset=1.0f;
        break;
        
    case 4: // s
		
    	plyr.facing = 3;
    	plyr.z_offset=1.0f;
		break;
    }
}


void turnRight()
{
    switch(plyr.facing)
    {
    case 2: // n
		
        plyr.facing = 3;
        plyr.z_offset=1.0f;
		break;

    case 1: // w
		
        plyr.facing = 2;
        plyr.z_offset=1.0f;
		break;

    case 3: // e
		
    	plyr.facing = 4;
        plyr.z_offset=1.0f;
		break;
        
    case 4: // s
    	plyr.facing = 1;
    	plyr.z_offset=1.0f;
		break;
    }	
}


void checkTeleport()
{
	
	if ( (plyr.special>=0xE0) && (plyr.special<=0xFF) ) // 224 - 255
 	{
      for (int i=0 ; i<=31 ; i++) // Max number of teleport objects
	{
 		//int ind = ((plyr.special)-0xEF);
		if (plyr.special == teleports[i].ref)
		{
			if (teleports[i].new_map == 0)
			{
				plyr.x = (teleports[i].new_x);
				plyr.y = (teleports[i].new_y);
			}
			if (teleports[i].new_map == 1)
			{
				plyr.x = (teleports[i].new_x)+32;
				plyr.y = (teleports[i].new_y);
			}
			if (teleports[i].new_map == 2)
			{
				plyr.x = (teleports[i].new_x);
				plyr.y = (teleports[i].new_y)+32;
			}
			if (teleports[i].new_map == 3)
			{
				plyr.x = (teleports[i].new_x)+32;
				plyr.y = (teleports[i].new_y)+32;
			}
			//plyr.facing = teleports[ind].new_facing;
			
			// Display flashing sequence for teleport.
			plyr.teleporting = 70;

			plyr.x++;
			plyr.y++;
			int location_index = getMapIndex(plyr.x, plyr.y);
			transMapIndex (location_index);	 	
		}
	  }
	}
	
}


void checkShop()
{
//	int drawTexture_no;
	if  ( ( (plyr.special>=0x01)&&(plyr.special<=0x1F) ) || (plyr.special==0x90) || (plyr.special==0x50)  || (plyr.special==0x70) 
 	|| (plyr.special==0x30) || (plyr.special==0xF0) || (plyr.special==208) || (plyr.special==176) || (plyr.special==5))
	{  
         switch(plyr.special)
         {
            case 0x0D: // damon
                //drawTexture_no = 24;
                shopDamon();
                break;
            case 0x0C: // guild
                //shopGuild();
                break;
            case 0x0F: // retreat
                //shopRetreat();
                break;
			case 0x1D: // rathskeller
                //shopRathskeller();
                break;
			case 0x50: // City Bank
				shopBank();
				break;
			case 0x90: // City Smithy
			    shopSmithy();
				break;
			case 0x70: // City Shop
				shopShop();
				break;
			case 0x10: // City Inn
			    shopInn();
				break;
			case 0x30: // City Tavern
			    shopTavern();
				break;
			case 0xF0: // City Guild
			    shopGuild();
				break;
			case 208: // City Healer
			    shopHealer();
				break;
			case 176: // Closed by order of the palace
				shopClosed();
				break;
			case 5:
				staircase();
				break;
        }	
        
 	
     }
}

void leaveShop()
{
     switch(plyr.facing)
    {
       case 1: // w
            plyr.x++;
            break;
    
        case 2: // n
            plyr.y++;
            break;
    
        case 3: // e
        	plyr.x--;
            break;
            
        case 4: // s
        	plyr.y--;
        	break;
    }	
	plyr.z_offset=1.6; // position player just outside door
	plyr.status = 1; // explore
}


void shopClosed()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	string str, key;
	plyr.status = 2; // shopping
	drawStatsPanel();
	cyText (0, "Closed by@@Order of the Palace@@@@@@( Press space to continue )");
	App.Display();
	pressKey();
	leaveShop();  
}


	
void shopDamon()
{
	int damonMenu = 1;
	string str,key;
	plyr.status = 2; // shopping
	while (damonMenu==1)
	{
		drawShopImage("imgDamon");
		drawStatsPanel();
		bText (1,1, "Welcome to our shoppe. I am Omar, Jeff's");
		bText (4,2, "twin brother.  How can I help you?");
		bText (6,4, "(1) Stocking up on provisions");
		bText (6,5, "(2) Selecting battle gear");
		bText (6,6, "(3) Choosing some apparel");
		bText (6,7, "(4) Exchanging currency");
		bText (6,8, "(0) Leave");
		App.Display();

		key = getSingleKey();
		if (key=="0") { damonMenu = 0; }
	}
	leaveShop();  
}


/*
void shopRetreat()
{
     //int drawTexture_no;
     string str;
     plyr.status = 2; // shopping
     
   //  beginGLScene();
   //  drawTop();	 	
  //   drawImage(26);
     glColor3ub(255,255,255); 
     
    drawText (2,1,"Welcome, Stranger, to our meagre hovel.");
     drawText (10,3,"Woulds't thou like to");
     drawText (14,5,"(1) Sleep");
     drawText (14,6,"(0) Leave");
  //   endGLScene();

   //  pressKey();
     //freeMusic();
     leaveShop();
     plyr.status = 1; // explore
     
}


void shopRathskeller()
{
     //int drawTexture_no;
     string str;
     plyr.status = 2; // shopping
      
   //  beginGLScene();
  //   drawTop();	 	
  //   drawImage(8);
     glColor3ub(255,255,255); 
      
     drawText (12,1,"Hello, Stranger!");
     drawText (6,3,"Where dost thou wish to sit?");
     drawText (12,5,"(1) At the bar");
     drawText (12,6,"(2) At a table");
     drawText (12,7,"(0) Leave");
 //    endGLScene();
     
 //    playMusic("rathskeller");
     pressKey();
 //    Mix_HaltMusic();
//	 freeMusic();
     leaveShop();
     plyr.status = 1; // explore
     
}



*/







