
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <string>
#include <iostream>
#include <sstream>

#include "player.h"
#include "font.h"
#include "display.h"
#include "explore.h"
#include "misc.h"
#include "inn.h"

extern Player plyr;
extern sf::RenderWindow App;

struct innRoom
{
	string name;
	int baseCost;
    int fatigueRecoveryProbability;

};

innRoom Rooms[10] =
{
	{"the common area floor",	10,		30},
	{"a bed with no bath",		20,		45},
	{"a bed with common bath",	30,		60},
	{"a room with common bath",	40,		85},
	{"a room with bath",		50,		100},
	{"a Premium Room",			100,	140},
	{"a Deluxe Room",			200,	170},
	{"a Small Suite",			400,	200},
	{"a Suite",					800,	240},
	{"our BEST Suite",			1600,	255}
};

struct Inn
{
       string name;
       float costMultiplier;
       int jobProbability;
	   int x;
	   int y;
};

Inn Inns[7] =
{
	{"Green Boar Inn",		1,		64,		24,		23},
	{"Lazy Griffin Inn",	2,		154,	24,		23},
	{"Sleeping Dragon Inn",	0.5,	64,		24,		23},
	{"Traveller's Inn",		6,		179,	32,		39},
	{"Midnight Inn",		3,		56,		24,		23},
	{"Warrior's Retreat",	0.75,	77,		24,		23},
	{"Royal Resort Inn",	8,		102,	24,		23}
};

struct innJobOpening
{
	int jobNumber;
	int JobHoursRequired;
	int jobHourlyIncome;
};


innJobOpening innJobOpenings[7];

struct innJob
{
	string name;
	int minIncome;
	int maxIncome;
	string statRequirementName;
	int statRequirementValue;
	float fatigueRate;
	float minorWoundProbability;
	float majorWoundProbability;
};

innJob innJobs[3] =
{
	{"Bellhop",	10,	24,	"Strength",	18,	0.6875, 15.95, 3.97},
	{"Desk Clerk",	18,	20,	"Charm",16,	0.5625, 3.75, 0.15},
	{"Janitor",	12,	15,	"Stamina",	17,	0.6250, 8.50, 0.88 }
};

void checkDailyJobOpenings()
{
	// Run at the start of each new day
	int jobOpeningProbability = 0;
	for (int i=0 ; i<7 ; i++) 
	{
		jobOpeningProbability  = sf::Randomizer::Random(0,255);
		if (jobOpeningProbability <= Inns[i].jobProbability) 
		{
			// Create a new job entry for the day
			int newJobNumber = sf::Randomizer::Random(0,2);
			innJobOpenings[i].jobNumber = newJobNumber;
			innJobOpenings[i].JobHoursRequired = sf::Randomizer::Random(3,8);
			innJobOpenings[i].jobHourlyIncome = sf::Randomizer::Random(innJobs[newJobNumber].minIncome,innJobs[newJobNumber].maxIncome);
			//innJobOpenings[i].jobHourlyIncome = sf::Randomizer::Random(10,20);
		}
		else
		{
			// No job available today
			innJobOpenings[i].jobNumber = 255; 
		}

	}
}



void shopInn()
{	

	int InnNo = getInnNo();

	int roomCost;
	int InnMenu = 1; // high level menu
	int roomChoice = 0;
	int sleepingHours = 1;
	int workingHours = 0;
	int hourlyRate = 0;
	int jobIncome = 0;

	//int InnLoc = 0; // bar, table or booth
	string str,key;
	plyr.status = 2; // shopping

	while (InnMenu > 0)
	{		
		while (InnMenu == 1) // main menu
		{
			
			drawShopImage("imgCityInn");
			drawStatsPanel();
			bText (6,0, "You are at the Inn's counter");
			bText (10,2, "Do you wish to");
			bText (12,4, " ) Stay the night");
			bText (12,5, " ) Check the time");
			bText (12,6, " ) Apply for a job");
			bText (12,7, " ) Leave");
			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);
			SetFontColour(40, 96, 244, 255);
			bText (12,4, "1");
			bText (12,5, "2");
			bText (12,6, "3");
			bText (12,7, "0");
			SetFontColour(255, 255, 255, 255);
			App.Display();


			key = pressKey();

			if ( key=="1" ) { InnMenu = 2; }
			if ( key=="2" ) { InnMenu = 7; }
			if ( key=="3" ) { InnMenu = 8; }
			if ( key=="0" ) { InnMenu = 0; }
		}

		while (InnMenu == 2) // first room booking menu
		{
			
			drawShopImage("imgCityInn");
			drawStatsPanel();
			bText (8,0, "Would you like to sleep in");
			bText (1,2, " ) the common area floor         coppers");
			bText (1,3, " ) a Bed with no bath            coppers");
			bText (1,4, " ) a Bed with common Bath        coppers");
			bText (1,5, " ) a Room, with common Bath      coppers");
			bText (1,6, " ) a Room with Bath              coppers");
			bText (1,7, " ) Something better");
			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);

			int room_cost, x;
			for (int i=0 ; i<5 ; i++) // Max number of room prices in this menu display
			{
				x = 30;
				room_cost = Rooms[i].baseCost * Inns[InnNo].costMultiplier;
				if (room_cost<100) { x = 31;}
				if (room_cost>999) { x = 29;}
				bText (x,(i+2),room_cost);
			}

			SetFontColour(40, 96, 244, 255);
			bText (1,2, "1");
			bText (1,3, "2");
			bText (1,4, "3");
			bText (1,5, "4");
			bText (1,6, "5");
			bText (1,7, "6");
			SetFontColour(255, 255, 255, 255);

			App.Display();

			//key = pressKey();
			key = getSingleKey();
			if ( key=="1" ) { roomChoice = 0; InnMenu = 4; }
			if ( key=="2" ) { roomChoice = 1; InnMenu = 4; }
			if ( key=="3" ) { roomChoice = 2; InnMenu = 4; }
			if ( key=="4" ) { roomChoice = 3; InnMenu = 4; }
			if ( key=="5" ) { roomChoice = 4; InnMenu = 4; }
			if ( key=="6" ) { InnMenu = 3; }
			if ( key=="0" ) { InnMenu = 0; }
		}

		while (InnMenu == 3) // Join Inn menu
		{
			
			
			drawShopImage("imgCityInn");
			drawStatsPanel();
			bText (8,0, "Would you like to sleep in");
			bText (1,2, " ) a Premium Room");
			bText (1,3, " ) a Deluxe Room");
			bText (1,4, " ) a Small Suite");
			bText (1,5, " ) a Suite");
			bText (1,6, " ) Our BEST Suite");
			bText (1,7, " ) Something cheaper");
			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);

			SetFontColour(40, 96, 244, 255);
			bText (1,2, "1");
			bText (1,3, "2");
			bText (1,4, "3");
			bText (1,5, "4");
			bText (1,6, "5");
			bText (1,7, "6");
			SetFontColour(255, 255, 255, 255);
			
			int room_cost, x;
			for (int i=5 ; i<10 ; i++) // Max number of room prices in this menu display
			{
				x = 29;
				room_cost = Rooms[i].baseCost * Inns[InnNo].costMultiplier;
				if (room_cost<1000) { x = 30; }
				bText (x,(i-3),room_cost);
				bText (34,(i-3),"coppers");
			}

			App.Display();

			key = getSingleKey();
			if ( key=="6" ) { InnMenu = 2; }
			if ( key=="1" ) { roomChoice = 5; InnMenu = 4; }
			if ( key=="2" ) { roomChoice = 6; InnMenu = 4; }
			if ( key=="3" ) { roomChoice = 7; InnMenu = 4; }
			if ( key=="4" ) { roomChoice = 8; InnMenu = 4; }
			if ( key=="5" ) { roomChoice = 9; InnMenu = 4; }
			if ( key=="0" ) { InnMenu = 0; }
		}

		while (InnMenu == 4) // Confirm room choice and rate
		{
			
			drawShopImage("imgCityInn");
			drawStatsPanel();
			cyText (0, "Our rate for sleeping in");
			str = Rooms[roomChoice].name + " is " + itos((Rooms[roomChoice].baseCost * Inns[InnNo].costMultiplier)) + " coppers.";
			cyText (1, str);
			cyText (3,"Do you wish to sign in?");
			cyText (5,"( es or  o)");
			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);
			SetFontColour(40, 96, 244, 255);
			cyText (5," Y      N  ");
			SetFontColour(255, 255, 255, 255);

			App.Display();

			key = getSingleKey();
			if ( key=="Y" ) { InnMenu = 5; }
			if ( key=="N" ) { InnMenu = 1; }
		}

		while (InnMenu == 5) // Check funds and display sleeping time choices
		{
			
			drawShopImage("imgCityInn");
			drawStatsPanel();
			roomCost = Rooms[roomChoice].baseCost * Inns[InnNo].costMultiplier;
			if (roomCost > plyr.copper)
			{
				cText ("I'm sorry, you have not the funds.");
				cyText (9,"( Press a key )");
				App.Display();
				key = getSingleKey();
				//if ( key=="SPACE" ) { InnMenu = 1; }
				if ( key!="" ) { InnMenu = 1; }
			}
			else
			{
				cyText (0,"How many hours from now do you wish");
				cyText (1,"your wake-up call to be set for");
				cyText (2,"(Maximum of 12 hours)?");
				bText (3,4," ) 1 hour    ) 2 hours   ) 3 hours");
				bText (3,5," ) 4 hours   ) 5 hours   ) 6 hours");
				bText (3,6," ) 7 hours   ) 8 hours   ) 9 hours");
				bText (3,7," ) 10 hours  ) 11 hours  ) 12 hours");
				SetFontColour(40, 96, 244, 255);
				bText (3,4,"1           2           3");
				bText (3,5,"4           5           6");
				bText (3,6,"7           8           9");
				bText (3,7,"A           B           C");
				SetFontColour(255, 255, 255, 255);
				App.Display();
				key = getSingleKey();
				
				if ( key=="1" ) { sleepingHours = 1; InnMenu = 6; }
				if ( key=="2" ) { sleepingHours = 2; InnMenu = 6; }
				if ( key=="3" ) { sleepingHours = 3; InnMenu = 6; }
				if ( key=="4" ) { sleepingHours = 4; InnMenu = 6; }
				if ( key=="5" ) { sleepingHours = 5; InnMenu = 6; }
				if ( key=="6" ) { sleepingHours = 6; InnMenu = 6; }
				if ( key=="7" ) { sleepingHours = 7; InnMenu = 6; }
				if ( key=="8" ) { sleepingHours = 8; InnMenu = 6; }
				if ( key=="9" ) { sleepingHours = 9; InnMenu = 6; }
				if ( key=="A" ) { sleepingHours = 10; InnMenu = 6; }
				if ( key=="B" ) { sleepingHours = 11; InnMenu = 6; }
				if ( key=="C" ) { sleepingHours = 12; InnMenu = 6; }
			}
		}
		
		while (InnMenu == 6) // Display sleeping message and wake up message
		{
			
			//sleepingHours = 100;
			while (sleepingHours>0)
			{
				
				drawShopImage("imgCityInn");
				drawStatsPanel();
				//bText (1,1,sleepingHours);
				cyText (2,"You are sleeping in");
				str = Rooms[roomChoice].name + ".";
				cyText (3,str);
				App.Display();
				for (int i=0 ; i<60 ; i++) // 60 minutes
				{
					sf::Sleep(0.01f);
					// check for diseases
					// modify fatigue
					// modify hitpoints
					// modify temporary magic bonuses
				}
				addHour();
				sleepingHours--;
			}
			
			
			drawShopImage("imgCityInn");
			drawStatsPanel();
			cyText (2,"Brave adventurer...");
			cyText (3,"It is time to wake up.");
			cyText (4,"I hope you rested well.");
			cyText (9,"( Press a key )");
			App.Display();
			//key = pressKey();
			key = getSingleKey();
			if (key!="") { plyr.copper-=roomCost; InnMenu = 1; }
			
		}


		while (InnMenu == 7) // Check time menu
		{
			
			drawShopImage("imgCityInn");
			drawStatsPanel();
			str = "Hour " + itos(plyr.hours) + " of day " + itos(plyr.days);
			bText (7,2, str);

			string monthDesc;
			switch(plyr.months)
			{
				case 1: 
					monthDesc = "Rebirth";
					break;
				case 2: 
					monthDesc = "Awakening";
					break;
				case 3: 
					monthDesc = "Winds";
					break;
				case 4: 
					monthDesc = "Rains";
					break;
				case 5: 
					monthDesc = "Sowings";
					break;
				case 6: 
					monthDesc = "First Fruits";
					break;
				case 7: 
					monthDesc = "Harvest";
					break;
				case 8: 
					monthDesc = "Final Reaping";
					break;
				case 9: 
					monthDesc = "The Fall";
					break;
				case 10: 
					monthDesc = "Darkness";
					break;
				case 11: 
					monthDesc = "Cold Winds";
					break;
				case 12: 
					monthDesc = "Lights";
					break;
			}
			str = "In the month of " + monthDesc;
			bText (7,3, str);
			str = "In year " + itos(plyr.years) + " since abduction";
			bText (7,4, str);
			cyText (9,"( Press a key )");
			App.Display();

			key = getSingleKey();
			if (key!="") { InnMenu = 1; }
		}

		while (InnMenu == 8) // apply for job
		{
			int jobNumber = innJobOpenings[InnNo].jobNumber;
			
			drawShopImage("imgCityInn");
			drawStatsPanel();
			if ( jobNumber == 255)
			{
				bText (7,0, "I'm sorry but there are no");
				cyText (1, "job openings at the moment.");
				cyText (9,"( Press a key )");
				App.Display();

				key = getSingleKey();
				//if ( key=="Y" ) { InnMenu = 9; }
				if ( key!="" ) { InnMenu = 1; }

			}
			else
			{	str = "We have an opening for a " + innJobs[jobNumber].name;
				cyText (0, str);
				str = "for " + itos(innJobOpenings[InnNo].JobHoursRequired) + " hours at " + itos(innJobOpenings[InnNo].jobHourlyIncome) + " coppers per hour.";
				cyText (1, str);
				cyText (3, "Would you like to apply?");
				cyText (5, "( es or  o)");
				SetFontColour(40, 96, 244, 255);
				cyText (5, " Y      N  ");
				SetFontColour(255, 255, 255, 255);
				App.Display();

				key = getSingleKey();
				if ( key=="Y" ) { InnMenu = 9; }
				if ( key=="N" ) { InnMenu = 1; }
			
			}

		

			
		}


		while (InnMenu == 9) // Check job stat requirements
		{
			int jobNumber = innJobOpenings[InnNo].jobNumber;
			string statRequirementName = innJobs[jobNumber].statRequirementName;
			int statRequirement = innJobs[jobNumber].statRequirementValue;
			int actualStat = 0;
			bool jobStatMet = false;
			
			// Check stat requirement met
			if ((statRequirementName == "Strength") && (statRequirement<=plyr.str)) { jobStatMet = true; }
			if ((statRequirementName == "Charm") &&	(statRequirement<=plyr.chr)) { jobStatMet = true; }
			if ((statRequirementName == "Stamina") && (statRequirement<=plyr.sta)) { jobStatMet = true; }

			
			drawShopImage("imgCityInn");
			drawStatsPanel();
			if (!jobStatMet)
			{
				str = "You will need more " + statRequirementName;
				cyText (0, str);
				cyText (1, "to get the job.");
				cyText (9,"( Press a key )");
				App.Display();

				key = getSingleKey();
				
				if ( key!="" ) { InnMenu = 1; }

			}
			else
			{	
				workingHours = innJobOpenings[InnNo].JobHoursRequired;
				hourlyRate = innJobOpenings[InnNo].jobHourlyIncome;
				jobIncome = workingHours*hourlyRate;
				InnMenu = 10;
			}
		}

		while (InnMenu == 10) // Display sleeping message and wake up message
		{
			
			
			while (workingHours>0)
			{
				
				drawShopImage("imgCityInn");
				drawStatsPanel();
				//bText (1,1,workingHours);
				cyText (2,"WORKING");
				App.Display();
				for (int i=0 ; i<60 ; i++) // 60 minutes
				{
					sf::Sleep(0.01f);
					// check for diseases
					// modify fatigue
					// modify hitpoints
					// modify temporary magic bonuses
				}
				addHour();
				workingHours--;
			}
			
			
			drawShopImage("imgCityInn");
			drawStatsPanel();
			// CHECK FOR INJURY
			cyText (2,"The job is completed.");
			str = "You have earned " + itos(jobIncome) + " coppers.";
			cyText (3,str);
			cyText (9,"( Press a key )");
			App.Display();
			//key = pressKey();
			key = getSingleKey();
			if (key!="") { plyr.copper+=jobIncome; innJobOpenings[InnNo].jobNumber=255; InnMenu = 1; }
			
		}


	}
	leaveShop();
}





int getInnNo()
{
	int Inn_no;
	for (int i=0 ; i<=6 ; i++) // Max number of Inn objects
	{
		if ((Inns[i].x == plyr.x) && (Inns[i].y == plyr.y))
		{
			Inn_no = i; // The number of the Inn you have entered
		}
	} 
	if ((plyr.x == 33) && (plyr.y == 40)) { Inn_no = 3; } //  Traveller's Inn second entrance
	return Inn_no;
}