
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <string>
#include <iostream>
#include <sstream>

#include "player.h"
#include "font.h"
#include "display.h"
#include "explore.h"
#include "misc.h"
#include "tavern.h"

extern Player plyr;
extern sf::RenderWindow App;
sf::Music tavernMusic;

/*
struct tavern
{
       string name;
       int x;
       int y;
       int z;
	   int removeCursesCost;
};


tavern taverns[12] =
{
	{"Thieves tavern",			44,	30,	0,	9000},
	{"Blue Wizards tavern",		19,	17,	0,	3000},
	{"Light Wizards tavern",		3,	60,	0,	2700},
	{"Green Wizards Academy",	12,	22,	0,	3000},
	{"Red Wizards University",	48,	50,	0,	3000},
	{"Dark Wizards tavern",		34,	43,	0,	3100},
	{"Star Wizards tavern",		28,	53,	0,	2000},
	{"Wizards of Chaos tavern",	51,	5,	0,	4000},
	{"Wizards of Law tavern",	62,	15,	0,	3800},
	{"tavern of Order",			58,	15,	0,	4000},
	{"Physicians tavern",		6,	50,	0,	7000},
	{"Assassins tavern",			56,	62,	0,	11000}
};

*/



inline std::string concat( int n, const char* str )
{
std::ostringstream ss;
ss << n;
ss << str;
return ss.str();
} 

/*
string itos(int i)	// convert int to string
{
	stringstream s;
	s << i;
	return s.str();
}
*/


void shopTavern()
{	
	
	//int tavernNo = gettavernNo();
	
	tavernMusic.SetLoop(true);
	bool musicPlaying = false;
	int tavernMenu = 1; // high level menu
	int tavernLoc = 0; // bar, table or booth
	string str,key;
	plyr.status = 2; // shopping

	while (tavernMenu > 0)
	{		
		while (tavernMenu == 1) // main menu
		{
			drawShopImage("imgCityTavern");
			drawStatsPanel();
			
			bText (7,0, "Welcome Stranger! You are at ");
			bText (7,1, "the entrance. Do you wish to");
			bText (9,3, " ) Go to the bar");
			bText (9,4, " ) Get a table");
			bText (9,5, " ) Sit in a private booth");
			bText (9,6, " ) Apply for a job");
			bText (9,7, " ) Leave");
			SetFontColour(40, 96, 244, 255);
			bText (9,3, "1");
			bText (9,4, "2");
			bText (9,5, "3");
			bText (9,6, "4");
			bText (9,7, "0");
			SetFontColour(255, 255, 255, 255);
			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);
			App.Display();

			if (!musicPlaying) 
			{	
				int Random = sf::Randomizer::Random(0, 2);
				if (Random ==0) { tavernMusic.OpenFromFile("data/audio/cityTavern1.ogg"); }
				if (Random ==1) { tavernMusic.OpenFromFile("data/audio/cityTavern2.ogg"); }
				if (Random ==2) { tavernMusic.OpenFromFile("data/audio/cityTavern3.ogg"); }
				tavernMusic.Play(); 
				musicPlaying = true; 
			}

			//key = pressKey();
			key = getSingleKey();

			if ( key=="1" ) { tavernMenu = 2; tavernLoc = 1; }
			if ( key=="2" ) { tavernMenu = 2; tavernLoc = 2;}
			if ( key=="3" ) { tavernMenu = 2; tavernLoc = 3;}
			if ( key=="0" ) { tavernMenu = 0; }
		}

		while (tavernMenu == 2) // at bar, table or booth menu
		{
			drawShopImage("imgCityTavern");
			drawStatsPanel();
			if ( tavernLoc == 1) { bText (7,0, "You are sitting at the bar."); bText (23,3, "A few nuts"); }
			if ( tavernLoc == 2) { bText (7,0, "You are at your table."); bText (26,3, "Popcorn"); }
			if ( tavernLoc == 3) { bText (7,0, "You are in a private booth."); bText (7,3, "A smokey torch  A few nuts"); tavernMusic.Stop(); musicPlaying = false; }
			bText (7,4, " ) Hail the Barkeeper");
			bText (7,5, " ) Hail the Waitress");
			bText (7,6, " ) Buy a round for the house");
			bText (7,7, " ) Leave");
			SetFontColour(40, 96, 244, 255);
			bText (7,4, "1");
			bText (7,5, "2");
			bText (7,6, "3");
			bText (7,7, "0");
			SetFontColour(255, 255, 255, 255);
			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);
			App.Display();

			key = getSingleKey();
			if ( key=="0" ) { tavernMenu = 0; }

			/*int removeCursesCost = taverns[tavernNo].removeCursesCost;
			drawStatsPanel();
			drawShopImage("imgCitytavern");
			
			cyText (0, "The charge for removing curses"); //itos(removeCursesCost) 
			std::ostringstream text;
			text << "is " << removeCursesCost << " coppers. Agreed?";		
			cyText (1,text.str());
			text.str("");
			cyText (3, "Yes or No");
			text << "Your coins in copper " << plyr.copper;
			cyText (9,text.str());

			App.Display();

			key = pressKey();

			if ( key=="N" ) { tavernMenu = 1; }
			if ( key=="Y" ) { tavernMenu = 2; }
		*/
		}

		while (tavernMenu == 3) // Join tavern menu
		{
			/*
			drawStatsPanel();
			drawShopImage("imgCitytavern");

			//bText (2,0, "We are deeply sorry but we cannot");
			//bText (5,1, "accept any apprentices at this time.");
			//bText (9,9, "( Press space to continue )");
			cText ("We are deeply sorry but we cannot@accept any apprentices at this time.");
			cyText (9,"( Press space to continue )");
			App.Display();

			key = pressKey();
			if ( key=="SPACE" ) { tavernMenu = 1; }
			*/
		}

	}
	if (musicPlaying) { tavernMusic.Stop(); }
	leaveShop();
}

int gettavernNo()
{

int tavern_no;
/*
for (int i=0 ; i<=12 ; i++) // Max number of tavern objects
	{
		if ((taverns[i].x == plyr.x) && (taverns[i].y == plyr.y))
		{
			tavern_no = i; // The number of the tavern you have entered
        }
   } 
*/
return tavern_no;
}